import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import org.gamecontrolplus.gui.*; 
import org.gamecontrolplus.*; 
import net.java.games.input.*; 
import processing.awt.PSurfaceAWT.SmoothCanvas; 
import javax.swing.JFrame; 
import java.awt.Dimension; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class AmperRacingWheelCal extends PApplet {

/**
 Basic demonstration of using a gamepad.
 
 When this sketch runs it will try and find
 a game device that matches the configuration
 file 'gamepad' if it can't match this device
 then it will present you with a list of devices
 you might try and use.
 
 The chosen device requires 3 sliders and 2 button.
 
 for Processing V3
 (c) 2020 Peter Lager
 */









ControlIO control;
Configuration config;
ControlDevice gpad;

final static int minWidth=200;
final static int minHeight=140;


int[] adc_x=new int[64], adc_y=new int[64], adc_rx=new int[64], adc_ry=new int[64];
float adc_vx=0, adc_vy, adc_vrx, adc_vry;
float adc_minx=4000, adc_miny=4000, adc_minrx=4000, adc_minry=4000;
float adc_maxx=-4000, adc_maxy=-4000, adc_maxrx=-4000, adc_maxry=-4000;
int ringcnt=0;
int n=4;
int counter=100;
int counter2=100;
boolean btn39=false,clutchmode=false,dbl=false,seq=false,clutch=false;


public void settings() {
  size(220, 140);
}

public void setup() {
  frameRate(20);
  surface.setResizable(true);
  surface.setLocation(10, 10);

  SmoothCanvas sc = (SmoothCanvas) getSurface().getNative();
  JFrame jf = (JFrame) sc.getFrame();
  jf.setMinimumSize(new Dimension(minWidth, minHeight));  


  surface.setTitle("AmperRacingWheel Clutch");
  // Initialise the ControlIO
  control = ControlIO.getInstance(this);
  // Find a gamepad that matches the configuration file. To match with any 
  // connected device remove the call to filter.
  gpad = control.filter(GCP.GAMEPAD).getMatchedDevice("AmperRaceWheelCTRL");
  if (gpad == null) {
    println("No suitable device configured");
    System.exit(-1); // End the program NOW!
  }
}

public void draw() {
  int i;
  boolean btn2,btn3,btn4,btn5,btn6,btn7,btn8,btn15,btn16,btn17,btn18=false,btn19=false;
  ringcnt%=n;
  background(127, 127, 127);
  textSize(14);   
  
  btn2=gpad.getButton("B2").pressed();
  btn3=gpad.getButton("B3").pressed();
  btn4=gpad.getButton("B4").pressed();
  btn5=gpad.getButton("B5").pressed();
  btn6=gpad.getButton("B6").pressed();
  btn7=gpad.getButton("B7").pressed();
  btn8=gpad.getButton("B8").pressed();
  btn16=gpad.getButton("B16").pressed();
  btn15=gpad.getButton("B15").pressed();
  btn17=gpad.getButton("B17").pressed();
  btn18=gpad.getButton("B18").pressed();
  btn19=gpad.getButton("B19").pressed();
  //btn39=gpad.getButton("B39").pressed();
  if(btn7){background(255, 127, 127);dbl=true;}
  if(btn15){background(255, 0, 0);}
  if(btn16){background(0, 255, 127); counter=0; btn39=false; clutchmode=false; seq=false; counter2=0; clutch=false;}
  if(btn17){background(0, 0, 255);}
  if(btn18){background(0, 255, 255);}
  if(btn19){background(255, 255, 0);}
  
  if(btn17 && btn15&&(!seq)){
    counter--; 
    background(255, 0, 255);
    textSize(12);
    text("hold Button 14 & 16 for "+PApplet.parseInt(1+counter/17)+"sec to", 10,(height-40));
    text("enter Clutch programming mode", 10,(height-28));
    if(counter<4){counter=4; btn39=true; clutch=true;}
  }else {counter=100;}
 
  if(btn18 && btn19&&(!clutch)){
    counter2--; 
    background(255, 0, 255);
    textSize(12);
    text("hold Button 17 & 18 for "+PApplet.parseInt(1+counter2/17)+"sec to", 10,(height-40));
    text("enter Sequence programming mode", 10,(height-28));
    if(counter2<4){counter2=4; btn39=true; seq=true;}
  }else {counter2=100;}

  textSize(12);
  if(btn39&&clutch&&(!seq)){
    background(255, 127, 127); 
    if(btn2&&btn3){clutchmode=true;}
    if(!clutchmode){
      background(255, 50, 255); 
      text("Clutch Programming Mode", 20,(12)); 
      text("Exit with Button 16", 50,(24)); 
      if(btn7){dbl=true;}
      if(btn8){dbl=false;}
     } else {text("Threshold Programming Mode", 40,(12));}
  }

  if(btn39&&seq&&(!clutch)){
    background(100, 100, 100); 
    text("Sequence Programming Mode", 20,(12)); 
    text("Exit with Button 16", 50,(24)); 
    text("1. select Button to program", 20,(height-53)); 
    text("2. press Buttons for sequence", 20,(height-42)); 
    text("3. press initial Button to complete", 20,(height-31)); 
    text("4. repeat with 1. or exit", 20,(height-20)); 
  }

  adc_minx=min(adc_minx, 4095.0f*gpad.getSlider("ADC_X").getValue());
  adc_maxx=max(adc_maxx, 4095.0f*gpad.getSlider("ADC_X").getValue());
  
  adc_minrx=min(adc_minrx, 4000.0f*gpad.getSlider("ADC_RX").getValue());
  adc_maxrx=max(adc_maxrx, 4000.0f*gpad.getSlider("ADC_RX").getValue());
  
  adc_miny=min(adc_miny, 4095.0f*gpad.getSlider("ADC_Y").getValue());
  adc_maxy=max(adc_maxy, 4095.0f*gpad.getSlider("ADC_Y").getValue());
  
  adc_minry=min(adc_minry, 4000.0f*gpad.getSlider("ADC_RY").getValue());
  adc_maxry=max(adc_maxry, 4000.0f*gpad.getSlider("ADC_RY").getValue());

  adc_minx=-4095; adc_maxx=1215; //2215
  adc_miny=-4095; adc_maxy=1215;
  adc_minrx=-4095; adc_maxrx=3114;
  adc_minry=-4095; adc_maxry=3114;

  adc_x[ringcnt]  = round( map( 4095.0f*gpad.getSlider("ADC_X").getValue() ,adc_minx, adc_maxx,0.0f,1000.01f ) );
  adc_y[ringcnt]  = round( map( 4095.0f*gpad.getSlider("ADC_Y").getValue() ,adc_miny, adc_maxy,0.0f,1000.01f ) );
  adc_rx[ringcnt] = round( map( 4095.0f*gpad.getSlider("ADC_RX").getValue() ,adc_minrx, adc_maxrx,0.0f,1000.01f ) );
  adc_ry[ringcnt] = round( map( 4095.0f*gpad.getSlider("ADC_RY").getValue() ,adc_minry, adc_maxry,0.0f,1000.01f ) );
  adc_vx=0;
  adc_vy=0;
  adc_vrx=0;
  adc_vrx=0;
  for(i=0; i<n; i++){adc_vx+=adc_x[i]; adc_vy+=adc_y[i]; adc_vrx+=adc_rx[i]; adc_vry+=adc_ry[i];}
  adc_vx=round(10.0f*adc_vx/n)/100.0f;
  adc_vy=round(10.0f*adc_vy/n)/100.0f;
  adc_vrx=round(10.0f*adc_vrx/n)/100.0f;
  adc_vry=round(10.0f*adc_vry/n)/100.0f;
//  textAlign(LEFT);
//  text("Left Switch", 10,30); text("Right Switch", 120,30);
//  textAlign(RIGHT);
  //text(int(adc_vx)+" ", 70,30);  text(int(adc_vy)+" ", 180,30);
  //adc_vx=round(adc_vx);
  //adc_vy=round(adc_vy);
  adc_vx=round(10.0f*adc_vx)/10.0f;
  adc_vy=round(10.0f*adc_vy)/10.0f;
  textAlign(LEFT);
 // text("ADC Counts - raw data:", 10,30);
  text("Left Clutch", 10,50); text("Right Clutch", 120,50);
  textAlign(RIGHT);
  if((adc_vx<4001) && (adc_vy<4001) && (adc_vx>-1) && (adc_vy>-1)) text((adc_vx)+" ", 70,70);  text((adc_vy)+" ", 180,70);

  textSize(10);   
  textAlign(LEFT);
  text("powered by GameController+", 10,(height-10));

  ringcnt++;
}
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "AmperRacingWheelCal" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
